"{ Package: 'stx:libbasic' }"

ExternalBytes subclass:#MappedExternalBytes
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'System-Support'
!


!MappedExternalBytes methodsFor:'freeing'!

finalize
    "some MappedExternalBytes object was finalized;
     free the associated heap memory with it"

%{  /* NOCONTEXT */
#if defined(HAS_MMAP)

    char *_mem = (char *)(__INST(address_));
    OBJ sz = __INST(size);

# ifdef SUPERDEBUG
    fprintf(stderr, "finalize\n");
# endif
    if (__isSmallInteger(sz)) {
        if (_mem && (OBJ)_mem != nil) {
# ifdef SUPERDEBUG
            fprintf(stderr, "munmap (%x, %d)\n", _mem, __intVal(sz));
# endif
            munmap (_mem, __intVal(sz));
        }
        __INST(address_) = __INST(size) = nil;
    }
#endif /* HAS_MMAP */
%}
! !

!MappedExternalBytes class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic/MappedExternalBytes.st,v 1.1 2003-04-10 11:01:30 penk Exp $'
! !
